/* netguard-2.0.0/ethernet.c */
/* Copyright (c) 2000 monk <lizard8@iname.com>. */
/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

#include "hand-incl.h"
#include <netinet/if_ether.h>
#include "common.h"

/*
 * void ether_hand(u_char *, const struct pcap_pkthdr *, const u_char *);
 *
 */

#define ETH_HDRLEN	0xe

void ether_hand(unsigned char *user, struct pcap_pkthdr *pkt, unsigned char *p) {
 struct ether_header *ehdr;
 int i;

 ehdr=malloc(ETH_HDRLEN);
 if(!ehdr) return;
 memcpy(ehdr, p, ETH_HDRLEN);

 if(debug>2) {
  fprintf(stderr, "*** ETH datagram from: ");
  for(i=0;i<6;i++) 
   fprintf(stderr, "%x:", ehdr->ether_shost[i]);
  fprintf(stderr, "\n");
  fflush(stderr);
 }

 if((ehdr->ether_type)!=ntohs(ETHERTYPE_IP)) {
 if(debug>1) {
  logmsg("non-ip datagram on ethernet interface (0x%x)", ntohs(ehdr->ether_type));
 }
  return;
 }
 
 hand_ip(pkt, p+ETH_HDRLEN, pkt->len-ETH_HDRLEN);
 free(ehdr);
}
 
