/* netguard-2.0.0/fddi.c */
/* Copyright (c) 2000 monk <lizard8@iname.com>. */
/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

#include "hand-incl.h"
#include <netinet/if_fddi.h>
#include "common.h"

/*
 * void ether_hand(u_char *, const struct pcap_pkthdr *, const u_char *);
 *
 */

#define FDDI_HDRLEN	sizeof(struct fddi_header)

void fddi_hand(unsigned char *user, struct pcap_pkthdr *pkt, unsigned char *p) {
 struct fddi_header *ehdr;

 ehdr=malloc(FDDI_HDRLEN);
 if(!ehdr) return;
 memcpy(ehdr, p, FDDI_HDRLEN);

 hand_ip(pkt, p+FDDI_HDRLEN, pkt->len-FDDI_HDRLEN);
 free(ehdr);
}
 
