/* netguard-2.0.0/log.c */
/* Copyright (c) 2000 monk <lizard8@iname.com>. */
/*
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

#include <syslog.h>
#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <time.h>
#include "log.h"

static char lastmsg[1024];
int rep=0, fl=0;

int log_init() {
 logf=fopen(NGLOG_FILE, "at");
 if(logf<0) return 1;
 return 0;
}

void logmsg(char *fmt, ...) {
 va_list args;
 int rep1;
 static char rezbuff[4096];
 #ifdef NGLOG_FILE
 static char *tme;
 static time_t *t;

 tme=malloc(1024);
 t=malloc(1024);
 #endif

 va_start(args, fmt);
 vsprintf(rezbuff, fmt, args);
 va_end(args);

 if(!strcmp(rezbuff, lastmsg)) {
  rep++; return;
 }
 
 if(rep>1) {
  rep1=rep;
  rep=0;
  //logmsg("last message repeated %d more times.", rep1);
  sprintf(rezbuff, "last message repeated %d more times.", rep1);
 };

 strcpy(lastmsg, rezbuff);

 #ifdef NGLOG_STDOUT
 fprintf(stdout, "%s\n", rezbuff); fflush(stdout);
 #endif


 #ifdef NGLOG_SYSLOG
 openlog("netguard", LOG_PID, LOG_USER);
 syslog(LOG_INFO, "%s", rezbuff);
 closelog();
 #endif

 #ifdef NGLOG_FILE
 if(tme) {
   time(t); tme=ctime(t); tme[19]=0;
  }
  tme+=4;
  fprintf(logf, "%s %s\n", tme, rezbuff);
  fflush(logf);
 #endif
}

